<script>
  import Layout from "../components/Layout.svelte";
  import { Textarea, Button, Toggle, Toast } from "flowbite-svelte";
  import {
    Table,
    TableBody,
    TableBodyCell,
    TableBodyRow,
    TableHead,
    TableHeadCell,
    Checkbox,
  } from "flowbite-svelte";
  import { onMount } from "svelte";
  import { urlAPI } from "../utils/constants";
  import { FireOutline } from "flowbite-svelte-icons";

  let textareaprops = {
    id: "message",
    name: "message",
    label: "Your message",
    rows: 4,
    placeholder: "Escribe el texto para tu correo...",
  };

  let dataGrupos = [];
  let toastMessageError = "";
  let contentMailValue = "";
  let currentGroupId = 0;
  let open = false;

  const getDataGrupos = async () => {
    try {
      const response = await fetch(urlAPI + "/grupos");
      const result = await response.json();
      console.log(result);
      dataGrupos = result; // Asigna los datos de la API a la variable data
    } catch (error) {
      console.error("Error al obtener datos de la API:", error.message);
      toastMessageError = error.message;
      // open = true;
    }
  };

  const sendEmailToGroup = async () => {
    if (!currentGroupId || currentGroupId == 0) {
      return
    }


    try {
      const response = await fetch(
        urlAPI + `/grupos/send-email/${currentGroupId}`,
        {
          method: "POST",
          headers: {
            "Content-Type": "application/json",
          },
          body: JSON.stringify({ content: contentMailValue }),
        },
      );

      const result = await response.json();

      open = true;
      toastMessageError = result.message;
      console.log(result);
    } catch (error) {
      console.error("Error al enviar el correo", error.message);
      toastMessageError = error.message;
    }
  };

  const handleCheckboxChange = (id) => {
    if (currentGroupId !== id) {
      currentGroupId = id;
    } else {
      currentGroupId = 0;
    }
  };

  onMount(() => {
    getDataGrupos();
  });
</script>

<Layout>
  <Toast bind:open position="bottom-right">
    <FireOutline
      slot="icon"
      class="w-5 h-5 text-primary-500 bg-primary-100 dark:bg-primary-800 dark:text-primary-200"
    />
    {toastMessageError}
  </Toast>
  <h1 class="mb-5">Emails to send</h1>
  <div class="flex mb-5 w-full">
    <div class="w-2/4 pr-4">
      <Textarea {...textareaprops} bind:value={contentMailValue} />
    </div>
    <div class="w-2/4 pl-4">
      <Table hoverable={true}>
        <TableHead>
          <TableHeadCell class="!p-4"></TableHeadCell>
          <TableHeadCell>ID</TableHeadCell>
          <TableHeadCell>Nombre</TableHeadCell>
          <TableHeadCell>Descripción</TableHeadCell>
          <TableHeadCell>Correos</TableHeadCell>
        </TableHead>
        <TableBody tableBodyClass="divide-y">
          {#each dataGrupos as item (item.id)}
            <TableBodyRow key={item.id}>
              <TableBodyCell class="!p-4">
                <Checkbox
                  checked={currentGroupId === item.id}
                  on:change={() => handleCheckboxChange(item.id)}
                />
              </TableBodyCell>
              <TableBodyCell>{item.id}</TableBodyCell>
              <TableBodyCell>{item.name}</TableBodyCell>
              <TableBodyCell>{item.description}</TableBodyCell>
              <TableBodyCell>
                {#each item.correos as correo (correo.id)}
                  <h1>{correo.email}</h1>
                {/each}
              </TableBodyCell>
            </TableBodyRow>
          {/each}
        </TableBody>
      </Table>
    </div>
  </div>
  <div class="flex justify-center">
    <Button on:click={sendEmailToGroup} disabled={!currentGroupId || currentGroupId == 0}>Enviar correo</Button>
  </div>
</Layout>
